; tabstop=8
;
;
	ORG	0F000H

	JP	PCMSTART
	JP	INTMASK
	JP	INIT8251


MODE8251:
	DB	4FH		; stop=1/parity=none/length=8bit/clock=x64
RXMODE:
	DB	82H		; DSR=on/RxRDY=1


PCMSTART:

	DI
		; AY-3-8910 ̐ݒ
	LD	C,0A1H
	LD	A,07H
	OUT	(0A0H),A
	LD	B,0BFH
	OUT	(C),B		; g[A/B/C fBZ[u
	INC	A
	OUT	(0A0H),A
	LD	B,0DH
	OUT	(C),B		; |[gA ̉ʂlɁi0x80j
	INC	A
	OUT	(0A0H),A
	LD	B,09H
	OUT	(C),B		; |[gB ̉ʂlɁi0x80j
	INC	A
	OUT	(0A0H),A
	LD	B,00H
	OUT	(C),B		; |[gC ̉ʂlɁi0x80j


	LD	A,02H
	OUT	(093H),A	; oXNGXgOFF

	LD	A,37H
	OUT	(81H),A		; RTS=on

LOOP:
	IN	A,(81H)
	AND	02H
	JR	Z,LOOP
	IN	A,(80H)
	LD	E,A

		; ʃe[u

	LD	D,00H		; 7+1
	LD	HL,PCMTABLE	; 10+1
	ADD	HL,DE		; 11+1
	ADD	HL,DE		; 11+1
	ADD	HL,DE		; 11+1
	LD	B,(HL)		; 7+1
	INC	HL		; 6+1
	LD	D,(HL)		; 7+1
	INC	HL		; 6+1
	LD	E,(HL)		; 7+1
				; 93 / 125

		; A`C̃{[óB
		; ʂȂ悤ɏo邾B

	LD	C,0A1H		; 7+1
	LD	A,08H		; 7+1
	OUT	(0A0H),A	; 11+2
	OUT	(C),B		; 12+3
	INC	A		; 4+1
	OUT	(0A0H),A	; 11+2
	OUT	(C),D		; 12+3
	INC	A		; 4+1
	OUT	(0A0H),A	; 11+2
	OUT	(C),E		; 12+3
				; 110 / 235

	JR	LOOP


INTMASK:
	DI
	LD	A,73H
	LD	(0FA04H),A	; RS232C̊荞݂XLbv
	EI
	RET

INIT8251:
	DI
	LD	A,(MODE8251)
	LD	B,A
	LD	A,12H
	OUT	(81H),A		; RTS=off/DTR=on/Tx=Disable/Rx=Disable/Error clear
	LD	A,52H
	OUT	(81H),A		; 8251 Reset
	NOP			; wait
	NOP
	NOP
	NOP
	LD	A,B
	OUT	(81H),A		; 8251 mode set
	LD	A,37H
	OUT	(81H),A		; RTS=on/DTR=on/Tx=Enable/Rx=Ensable/Error clear
	EI
	RET



	; ʃf[^B|[gAABACȀB

PCMTABLE:
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 0 ,  0 ,  0
	DB	 1 ,  0 ,  0
	DB	 3 ,  0 ,  0
	DB	 4 ,  0 ,  0
	DB	 5 ,  0 ,  0
	DB	 5 ,  1 ,  0
	DB	 5 ,  3 ,  0
	DB	 6 ,  2 ,  0
	DB	 7 ,  0 ,  0
	DB	 7 ,  1 ,  0
	DB	 7 ,  3 ,  0
	DB	 7 ,  4 ,  0
	DB	 7 ,  5 ,  0
	DB	 8 ,  2 ,  0
	DB	 8 ,  2 ,  1
	DB	 8 ,  2 ,  3
	DB	 9 ,  0 ,  0
	DB	 9 ,  1 ,  0
	DB	 9 ,  3 ,  0
	DB	 9 ,  4 ,  0
	DB	 9 ,  5 ,  0
	DB	 9 ,  5 ,  1
	DB	 9 ,  5 ,  3
	DB	 9 ,  6 ,  2
	DB	10 ,  2 ,  0
	DB	10 ,  2 ,  1
	DB	10 ,  2 ,  3
	DB	10 ,  2 ,  4
	DB	10 ,  2 ,  5
	DB	10 ,  6 ,  1
	DB	10 ,  6 ,  3
	DB	10 ,  6 ,  4
	DB	11 ,  0 ,  0
	DB	11 ,  1 ,  0
	DB	11 ,  3 ,  0
	DB	11 ,  4 ,  0
	DB	11 ,  5 ,  0
	DB	11 ,  5 ,  1
	DB	11 ,  5 ,  3
	DB	11 ,  6 ,  2
	DB	11 ,  7 ,  0
	DB	11 ,  7 ,  1
	DB	11 ,  7 ,  3
	DB	11 ,  7 ,  4
	DB	11 ,  7 ,  5
	DB	12 ,  0 ,  0
	DB	12 ,  1 ,  0
	DB	12 ,  3 ,  0
	DB	12 ,  4 ,  0
	DB	12 ,  5 ,  0
	DB	12 ,  5 ,  1
	DB	12 ,  5 ,  3
	DB	12 ,  6 ,  2
	DB	12 ,  7 ,  0
	DB	12 ,  7 ,  1
	DB	12 ,  7 ,  3
	DB	12 ,  7 ,  4
	DB	12 ,  7 ,  5
	DB	12 ,  8 ,  2
	DB	12 ,  8 ,  4
	DB	11 , 10 ,  6
	DB	12 ,  9 ,  0
	DB	12 ,  9 ,  1
	DB	12 ,  9 ,  3
	DB	13 ,  0 ,  0
	DB	13 ,  1 ,  0
	DB	13 ,  3 ,  0
	DB	13 ,  4 ,  0
	DB	13 ,  5 ,  0
	DB	13 ,  5 ,  1
	DB	13 ,  5 ,  3
	DB	13 ,  6 ,  2
	DB	13 ,  7 ,  0
	DB	13 ,  7 ,  1
	DB	13 ,  7 ,  3
	DB	13 ,  7 ,  4
	DB	13 ,  7 ,  5
	DB	13 ,  8 ,  2
	DB	12 , 11 ,  1
	DB	12 , 11 ,  3
	DB	13 ,  9 ,  0
	DB	13 ,  9 ,  1
	DB	13 ,  9 ,  3
	DB	13 ,  9 ,  4
	DB	13 ,  9 ,  5
	DB	12 , 11 ,  7
	DB	13 ,  9 ,  6
	DB	13 ,  8 ,  8
	DB	13 ,  9 ,  7
	DB	13 , 10 ,  3
	DB	14 ,  0 ,  0
	DB	14 ,  1 ,  0
	DB	14 ,  3 ,  0
	DB	14 ,  4 ,  0
	DB	14 ,  5 ,  0
	DB	14 ,  5 ,  1
	DB	14 ,  5 ,  3
	DB	14 ,  6 ,  2
	DB	14 ,  7 ,  0
	DB	14 ,  7 ,  1
	DB	14 ,  7 ,  3
	DB	14 ,  7 ,  4
	DB	14 ,  7 ,  5
	DB	14 ,  8 ,  2
	DB	13 , 11 ,  7
	DB	14 ,  8 ,  4
	DB	14 ,  9 ,  0
	DB	14 ,  9 ,  1
	DB	14 ,  9 ,  3
	DB	14 ,  9 ,  4
	DB	14 ,  9 ,  5
	DB	13 , 12 ,  3
	DB	13 , 12 ,  4
	DB	13 , 12 ,  5
	DB	14 , 10 ,  2
	DB	14 , 10 ,  3
	DB	14 , 10 ,  4
	DB	13 , 12 ,  7
	DB	14 , 10 ,  6
	DB	13 , 11 , 10
	DB	14 , 10 ,  7
	DB	14 , 10 ,  7
	DB	14 , 11 ,  0
	DB	14 , 11 ,  1
	DB	14 , 11 ,  3
	DB	14 , 11 ,  4
	DB	14 , 11 ,  5
	DB	15 ,  0 ,  0
	DB	13 , 13 ,  0
	DB	15 ,  2 ,  0
	DB	15 ,  2 ,  1
	DB	15 ,  3 ,  2
	DB	15 ,  4 ,  2
	DB	15 ,  6 ,  0
	DB	15 ,  6 ,  1
	DB	15 ,  6 ,  3
	DB	15 ,  6 ,  4
	DB	15 ,  7 ,  2
	DB	14 , 12 ,  4
	DB	15 ,  8 ,  0
	DB	15 ,  8 ,  1
	DB	15 ,  8 ,  3
	DB	15 ,  8 ,  4
	DB	15 ,  8 ,  5
	DB	13 , 13 ,  9
	DB	15 ,  9 ,  2
	DB	15 ,  9 ,  3
	DB	15 ,  8 ,  7
	DB	15 ,  9 ,  5
	DB	15 ,  9 ,  6
	DB	15 , 10 ,  0
	DB	15 , 10 ,  1
	DB	15 , 10 ,  3
	DB	15 , 10 ,  4
	DB	15 , 10 ,  5
	DB	15 ,  9 ,  8
	DB	14 , 13 ,  3
	DB	14 , 13 ,  4
	DB	15 , 10 ,  7
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0
	DB	15 , 11 ,  0



